﻿// JScript 文件
var g_curSelectRowIndex=-1;  //ListCtrl当前选中的行号

/******************************************************************************
功能：	通过table控件创建列表对象
参数：	htmlObj - table ID
		colNum - 列表的列数
		colHeaders - 列表的表头字符串数组
		rowInitNum - 初始化行数
返回值：创建的列表对象，可用来访问对象的方法
******************************************************************************/
function CreateListCtrl(htmlObj, colNum, colHeaders, rowInitNum)
{
	listCtrl = new Object();
	listCtrl.colNum = colNum;
	listCtrl.htmlObj = htmlObj;
	listCtrl.colHeaders = colHeaders;
	listCtrl.bEnable = true;
	
	listCtrl.AddOneItem = AddOneItem;
	listCtrl.DelOneItem = DelOneItem;
	listCtrl.GetItemCount = GetItemCount;
	listCtrl.GetCurSel = GetCurSel;
	listCtrl.ChangeItem = ChangeItem;
	listCtrl.GetItem = GetItem;
	listCtrl.Clear = ClearList;
	
	//zld 2010/9/7 支持safari
//	var strOuterHTML = htmlObj.outerHTML.toLowerCase();
//	var lengthLimit = strOuterHTML.indexOf("</tbody>");
//	strOuterHTML = strOuterHTML.substr(0, lengthLimit);
	var strOuterHTML="<table id='table_user'  class='main_table' style='width: 750px;'>";
	strOuterHTML += "<tbody>";
	//添加标题行
	strOuterHTML += "<tr class = 'table_head_bgcolor'>";
	for(var i = 0; i < colNum; i++)
	{
		strOuterHTML += "<td style = 'width:250px;'>" + colHeaders[i] + "</td>";
	}
	strOuterHTML += "</tr>";
	//添加数据行
	for(var i = 1; i < rowInitNum + 1; i++)
	{
		strOuterHTML += "<tr onclick='OnClick_" + htmlObj.id + "_Item(this)'>";
		for(var j = 0; j < colNum; j++)
		{
			strOuterHTML += "<td></td>";
		}
		strOuterHTML += "</tr>";
	}
	
	strOuterHTML += "</tbody></table>";
	
	var parentNode = htmlObj.parentElement;
	
	parentNode.innerHTML = strOuterHTML;
	listCtrl.htmlObj = parentNode.childNodes[0];
	
	return listCtrl;
}

/******************************************************************************
功能：	向列表中添加一行数据
参数：	itemData - 要插入到列表中的一个数据元组
返回值：返回该项在列表中的索引，从0开始
******************************************************************************/
function AddOneItem(itemData)
{
	var rows = this.htmlObj.rows;
	for(var i = 1; i < rows.length; i++)
	{
		if(rows[i].cells[0].innerText == "")
		{
			for(var j = 0; j < itemData.length; j++)
			{
				rows[i].cells[j].innerText = itemData[j];
			}
			break;
		}
	}
}

/******************************************************************************
功能：	从列表中删除一行数据
参数：	index - 从0开始的数据索引
******************************************************************************/
function DelOneItem(index)
{
	index += 1;	//第一行是标题
	var rows = this.htmlObj.rows;
	if(rows[index].cells[0].innerText == "")
	{
		return;
	}
	for(var j = 0; j < this.colNum; j++)
	{
		rows[index].cells[j].innerText = "";
	}
	
	for(var i = index; (i+1 < rows.length) && (rows[i+1].cells[0].innerText != ""); i++)
	{
		for(var j = 0; j < this.colNum; j++)
		{
			rows[i].cells[j].innerText = rows[i+1].cells[j].innerText;
		}
	}
	for(var j = 0; j < this.colNum; j++)
	{
		rows[i].cells[j].innerText = "";
	}
}

/******************************************************************************
功能：	统计列表中有多少项数据
返回值：统计得出的数据项数
******************************************************************************/
function GetItemCount()
{
	var itemCount = 0;
	var rows = this.htmlObj.rows;
	for(var i = 1; i < rows.length; i++)
	{
		if(rows[i].cells[0].innerText == "")
		{
			break;
		}
		itemCount++;
	}
	return itemCount;
}

/******************************************************************************
功能：	得到当前选中的一行（高亮显示的）的索引号
返回值：从0开始的一个索引号
******************************************************************************/
function GetCurSel()
{
    var isIE = /msie/i.test(navigator.userAgent); 
	var rows = this.htmlObj.rows;
	for(var i = 1; i < rows.length; i++)
	{
	    if (isIE)
	    {
		    if(rows[i].style.backgroundColor.toUpperCase() == ptz_pincruise_sel_bg)
		    {
			    return i - 1;
		    }
		}
		else
		{
		    if ( g_curSelectRowIndex>0 && g_curSelectRowIndex==i) 
		    {
		        return i - 1;
		    }
		}
	}
	
	return -1;
}

function ChangeItem(index, newItemValues)
{
	index += 1;
	var rows = this.htmlObj.rows;
	for(var j = 0; j < this.colNum; j++)
	{
		rows[index].cells[j].innerText = newItemValues[j];
	}
}

function GetItem(index)
{
	index += 1;
	var rows = this.htmlObj.rows;
	var itemValues = new Array(this.colNum);
	for(var j = 0; j < this.colNum; j++)
	{
		itemValues[j] = rows[index].cells[j].innerText;
	}
	
	return itemValues;
}

function ClearList()
{
    var rows = this.htmlObj.rows;
	for(var i = 1; i < rows.length; i++)
	{
		if(rows[i].cells[0].innerText == "")
		{
			break;
		}
		for(var j = 0; j < rows[i].cells.length; j++)
		{
		    rows[i].cells[j].innerText = "";
		}
		rows[i].style.backgroundColor = "";
		rows[i].style.color = "black";
	}
}

/********************************************************************************
    功能：单击选中一行
******************************************************************************/
function OnClickItem(rowElem)
{  
	var table = rowElem.parentNode;
	for(i = 1; i < table.rows.length; i++)
	{
		table.rows[i].style.background=ptz_pincruise_unsel_bg;//底色
		table.rows[i].style.color = ptz_pincruise_unsel_color;
	}
	
	if(rowElem.cells[0].innerText != "")
	{
		rowElem.style.background=ptz_pincruise_sel_bg;//点击后的颜色
		rowElem.style.color = ptz_pincruise_sel_color;
        g_curSelectRowIndex=rowElem.rowIndex;
	}
}

function OnClick_table_user_Item(rowElem)
{
    g_curSelectRowIndex=-1;
    if(!g_userListCtrl.bEnable)
    {
        return;
    }
 
	OnClickItem(rowElem);
	
	if(((user_info_pane.style.display != "none")&&(btn_group_modify.style.display != "none"))||(modify_password.style.display != "none"))	//修改用户状态
	{
		if(g_userListCtrl.GetCurSel() == -1)
		{
			OnUserCancel();
			OnModPwdCancel();
			return;
		}
	    if(btn_group_modify.style.display == "")
	    {
	        OnModifyUser();
	    }
		if(modify_password.style.display == "")
		{
		    OnModPwd();
		}
	}
}